//+------------------------------------------------------------------+
//| Squize_MA_E_mtf                                    Squize_MA.mq4 |
//| mtf:ForexTSD.com 2007                                    Kalenzo |
//|                                      bartlomiej.gorski@gmail.com |
//+------------------------------------------------------------------+
//mladen's formula   ki 
#property copyright "Kalenzo"
#property link      "bartlomiej.gorski@gmail.com"
#property indicator_buffers 4
#property indicator_color1 Blue
#property indicator_color2 Red
#property indicator_color3 Yellow
#property indicator_color4 Goldenrod
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_width4 2

double upma[];
double dnma[];
double SqLup[]; 
double SqLdn[]; 

extern double  MAsThresHold = 3;
//extern color MA1_Color=Blue;       // ma colors (int.tab) - 4 referece only
extern int Ma1Period = 5;
extern int Ma1Type = MODE_EMA;
extern int Ma1Price = PRICE_CLOSE;
//extern color MA2_Color=Red;         // ma colors (int.tab) - 4 referece only
extern int Ma2Period = 21;
extern int Ma2Type = MODE_EMA;
extern int Ma2Price = PRICE_CLOSE;
extern bool alertsOn        = false;
extern bool alertsOnCurrent = true;
extern bool alertsMessage   = true;
extern bool alertsSound     = false;
extern bool alertsEmail     = false;

extern int     TimeFrame = 0;
extern string  note_TimeFrames = "M1;5,15,30,60H1;240H4;1440D1;10080W1;43200MN|0-CurrentTF";
extern string   note_MA_Type    = "SMA0 EMA1 SMMA2 LWMA3";
extern string   note_Price      = "0C 1O 2H 3L 4Md 5Tp 6WghC: Md(HL/2)4,Tp(HLC/3)5,Wgh(HLCC/4)6";

string IndicatorFileName;

#property indicator_chart_window

//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexBuffer(0,upma);
   SetIndexBuffer(1,dnma);
   SetIndexBuffer(2,SqLup);
   SetIndexBuffer(3,SqLdn);
   
   SetIndexLabel(0,"SqMA1("+Ma1Period+")["+TimeFrame+"]");
   SetIndexLabel(1,"SqMA2("+Ma2Period+")["+TimeFrame+"]");
   SetIndexLabel(2,"SqMA Env("+MAsThresHold+")("+Ma1Period+","+Ma2Period+")["+TimeFrame+"]");
   SetIndexLabel(3,"SqMA Env("+MAsThresHold+")("+Ma1Period+","+Ma2Period+")["+TimeFrame+"]");

//----
   IndicatorShortName("SquizeMA ("+Ma1Period+","+Ma2Period+")["+TimeFrame+"] ");
   TimeFrame =MathMax(TimeFrame, Period());
   IndicatorFileName = WindowExpertName();



   return(0);
  }
//+------------------------------------------------------------------+
int deinit()
  {
//----

   return(0);
  }

//+------------------------------------------------------------------+
int start()
  {
   int counted_bars=IndicatorCounted();
   if(counted_bars < 0) return(-1);
   if(counted_bars>0) counted_bars--;

   int      limit,i;
   limit = Bars-counted_bars;
   if (TimeFrame != Period())
       {
         limit = MathMax(limit,5*TimeFrame/Period());
        for(i=limit; i>=0; i--)
           {
              int y = iBarShift(NULL,TimeFrame,Time[i]);
               upma  [i] = iCustom(NULL,TimeFrame,IndicatorFileName,MAsThresHold,Ma1Period,Ma1Type,Ma1Price,Ma2Period,Ma2Type,Ma2Price,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,0,y);
               dnma  [i] = iCustom(NULL,TimeFrame,IndicatorFileName,MAsThresHold,Ma1Period,Ma1Type,Ma1Price,Ma2Period,Ma2Type,Ma2Price,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,1,y);
               SqLup [i] = iCustom(NULL,TimeFrame,IndicatorFileName,MAsThresHold,Ma1Period,Ma1Type,Ma1Price,Ma2Period,Ma2Type,Ma2Price,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,2,y);
               SqLdn [i] = iCustom(NULL,TimeFrame,IndicatorFileName,MAsThresHold,Ma1Period,Ma1Type,Ma1Price,Ma2Period,Ma2Type,Ma2Price,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,3,y);
            }
         return(0);         
        }


   //
   //
   //
   //
   //
   
   double treshold = MAsThresHold*Point; if (Digits==3 || Digits==5) treshold *= 10.0;
   for(i = limit; i>=0; i--)
   {
      double ma1 = iMA(Symbol(),0,Ma1Period,0,Ma1Type,Ma1Price,i);
      double ma2 = iMA(Symbol(),0,Ma2Period,0,Ma2Type,Ma2Price,i);       
      double madif = MathAbs(ma1-ma2);
 
         upma[i]  = ma1;
         dnma[i]  = ma2;
         SqLup[i] = EMPTY_VALUE;  
         SqLdn[i] = EMPTY_VALUE; 
         if(madif<treshold)
         {
            SqLup[i] = ma2+ treshold; 
            SqLdn[i] = ma2- treshold; 
         }
   }
   manageAlerts();
   return(0);
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (SqLup[whichBar] == EMPTY_VALUE && SqLup[whichBar+1]!=EMPTY_VALUE)
      {
         if (upma[whichBar] > dnma[whichBar]) doAlert(whichBar,"over");
         if (upma[whichBar] < dnma[whichBar]) doAlert(whichBar,"under");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" sueeze exited ma1 is "+doWhat+" ma2";
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(Symbol()+" ma squeeze",message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

